/*
 * 创客预设分润
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserProfitSetController : BaseController
    {
        public UserProfitSetController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 创客预设分润列表

        /// <summary>
        /// 根据条件查询创客预设分润列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserProfitSet data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            List<Users> TopUsers = db.Users.Where(m => m.ParentUserId == 0).ToList();
            ViewBag.TopUsers = TopUsers;
            List<KqProducts> Brands = db.KqProducts.OrderBy(m => m.Id).ToList();
            ViewBag.Brands = Brands;

            return View();
        }

        #endregion

        #region 根据条件查询创客预设分润列表

        /// <summary>
        /// 创客预设分润列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserProfitSet data, string MakerCode, string RealName, string CardTypeSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("UpdateDate", "3"); //设置时间
            Fields.Add("BrandId", "0"); //品牌
            Fields.Add("TopUserId", "0"); //顶级创客

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //交易卡类型
            if(!string.IsNullOrEmpty(CardTypeSelect))
            {
                condition += " and CardType=" + CardTypeSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserProfitSet", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int TopUserId = int.Parse(dic["TopUserId"].ToString());
                Users tuser = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopMakerCode"] = tuser.MakerCode;
                dic["TopRealName"] = tuser.RealName;
                int CardType = int.Parse(dic["CardType"].ToString());
                if(CardType == 0) dic["CardType"] = "借记卡";
                if(CardType == 1) dic["CardType"] = "贷记卡";
                int HelpFlag = int.Parse(dic["HelpFlag"].ToString());
                if(HelpFlag == 0) dic["HelpFlag"] = "非扶持期";
                if(HelpFlag == 1) dic["HelpFlag"] = "扶持期";
            }
            return Json(obj);
        }

        #endregion

        #region 增加创客预设分润

        /// <summary>
        /// 增加或修改创客预设分润信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加创客预设分润

        /// <summary>
        /// 增加或修改创客预设分润信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserProfitSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("BrandId", data.BrandId); //品牌

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserProfitSet", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserProfitSet", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改创客预设分润

        /// <summary>
        /// 增加或修改创客预设分润信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            UserProfitSet editData = db.UserProfitSet.FirstOrDefault(m => m.Id == Id) ?? new UserProfitSet();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改创客预设分润

        /// <summary>
        /// 增加或修改创客预设分润信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserProfitSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("BrandId", data.BrandId); //品牌

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserProfitSet", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserProfitSet", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除创客预设分润信息

        /// <summary>
        /// 删除创客预设分润信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserProfitSet", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserProfitSet", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserProfitSet", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserProfitSet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserProfitSet", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserProfitSet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserProfitSet", Sort, Id);

            AddSysLog(Id.ToString(), "UserProfitSet", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.UserProfitSet.Add(new UserProfitSet()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserProfitSet", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserProfitSet data, string MakerCode, string RealName, string CardTypeSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("UpdateDate", "3"); //设置时间
            Fields.Add("BrandId", "0"); //品牌
            Fields.Add("TopUserId", "0"); //顶级创客

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //交易卡类型
            if(!string.IsNullOrEmpty(CardTypeSelect))
            {
                condition += " and CardType=" + CardTypeSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserProfitSet", Fields, "Id desc", "0", 1, 20000, condition, "UserId,TopUserId,BrandId,CardType,HelpFlag,ProfitRate,ProfitPercent,AddOrSubRate,ProfitRateBase,Remark,UpdateMan,UpdateDate", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                int TopUserId = int.Parse(dic["TopUserId"].ToString());
                Users tuser = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopMakerCode"] = tuser.MakerCode;
                dic["TopRealName"] = tuser.RealName;
                int CardType = int.Parse(dic["CardType"].ToString());
                if(CardType == 0) dic["CardType"] = "借记卡";
                if(CardType == 1) dic["CardType"] = "贷记卡";
                int HelpFlag = int.Parse(dic["HelpFlag"].ToString());
                if(HelpFlag == 0) dic["HelpFlag"] = "非扶持期";
                if(HelpFlag == 1) dic["HelpFlag"] = "扶持期";
                dic.Remove("UserId");
                dic.Remove("TopUserId");
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("MakerCode", "创客编号");
            ReturnFields.Add("RealName", "创客姓名");
            ReturnFields.Add("TopMakerCode", "顶级创客编号");
            ReturnFields.Add("TopRealName", "顶级创客名称");
            ReturnFields.Add("BrandId", "产品名称");
            ReturnFields.Add("CardType", "交易卡类型");
            ReturnFields.Add("HelpFlag", "扶持期标识");
            ReturnFields.Add("ProfitRate", "创客预设分润比例");
            ReturnFields.Add("ProfitPercent", "创客预设分润百分比");
            ReturnFields.Add("AddOrSubRate", "浮动空间");
            ReturnFields.Add("ProfitRateBase", "分润比例基数");
            ReturnFields.Add("Remark", "备注信息");
            ReturnFields.Add("UpdateMan", "操作员");
            ReturnFields.Add("UpdateDate", "操作时间");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserProfitSet", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
